diff --git a/src/isdn/Q921.c b/src/isdn/Q921.c
index 2dad5cf..a682c23 100644
--- a/src/isdn/Q921.c
+++ b/src/isdn/Q921.c
@@ -435,30 +1889,1000 @@ int Q921SendDISC(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendUA(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendUA(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x63 | ((pf<<4)&0x10));
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x0c, mes, trunk->Q921HeaderSpace+3);
+}
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+static int Q921SendUN(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf, L2UCHAR *mes, L2INT size)
+{
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x00, mes, size+trunk->Q921HeaderSpace+3);
 }
 
-int Q921ProcSABME(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+
+/**
+ * Q921ProcSABME
+ * \brief	Handle incoming SABME
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcSABME(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
 {
-	/* TODO:  Do we need these paramaters? */
-	(void)mes;
-	(void)size;
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),	/* or command? */
+				tei, pf);
+
+		/* clear counters */
+		link->vr=0;
+		link->vs=0;
+		link->va=0;
+
+		/* TODO: send DL-Establish indication to Q.931 */
+		Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, tei, NULL, 0);
+
+		/* start T203 */
+		Q921T203TimerStart(trunk, tei);
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		/* send DM */
+		Q921SendDM(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* clear exception conditions */
+		Q921ResetExceptionConditions(trunk, tei);
+
+		/* send MDL-Error indication */
+
+		/* V(S) == V(A) ? */
+		if(link->vs != link->va) {
+			/* clear I queue */
+			MFIFOClear(link->IFrameQueue);
+
+			/* DL-Establish indication */
+			Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, tei, NULL, 0);
+		}
 
-    trunk->vr=0;
-    trunk->vs=0;
-	trunk->va=0;
+		/* clear counters */
+		link->vr=0;
+		link->vs=0;
+		link->va=0;
 
-    return 1;
+		/* Stop T200, start T203 */
+		Q921T200TimerStop(trunk, tei);
+		Q921T203TimerStart(trunk, tei);
+
+		/* state change only if in TIMER_RECOVERY state */
+		if(link->state == Q921_STATE_TIMER_RECOVERY)
+			Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcDM
+ * \brief	Handle incoming DM
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcDM(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+		if(!pf) {
+			/* to next state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+	case Q921_STATE_AWAITING_RELEASE:
+		if(pf) {
+			if(link->state == Q921_STATE_AWAITING_ESTABLISHMENT) {
+				/* Discard I queue */
+				MFIFOClear(link->IFrameQueue);
+			}
+
+			/* Send DL-Release indication to Q.931 */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE, tei, NULL, 0);
+
+			/* Stop T200 */
+			Q921T200TimerStop(trunk, tei);
+
+			/* Change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, tei);
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(pf) {
+			/* MDL-Error indication (B) */
+
+			/* no state change */
+		} else {
+			/* MDL-Error indication (E) */
+
+			/* establish data link */
+			Q921EstablishDataLink(trunk, tei);
+
+			/* clear L3 initiated */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+			/* change state (no action?) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(pf) {
+			/* MDL Error indication (B) */
+		} else {
+			/* MDL Error indication (E) */
+		}
+
+		/* establish data link */
+		Q921EstablishDataLink(trunk, tei);
+
+		/* clear layer 3 initiated */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+		/* change state */
+		Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+/**
+ * Q921ProcUA
+ * \brief	Handle incoming UA
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcUA(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* MDL Error indication (C, D) */
+		Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame in invalid state\n");
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		if(pf) {
+			/* TODO: other fancy stuff (see docs) */
+			if(Q921_CHECK_FLAG(link, Q921_FLAG_L3_INITIATED)) {	/* layer3 initiated */
+				link->vr = 0;
+
+				/* DL-Establish confirm */
+				Q921Tx23Proc(trunk, Q921_DL_ESTABLISH_CONFIRM, tei, NULL, 0);
+
+			} else if(link->vs != link->va) {
+
+				/* discard I queue */
+				MFIFOClear(link->IFrameQueue);
+
+				/* DL-Establish indication */
+				Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, tei, NULL, 0);
+			}
+
+			/* Stop T200, start T203 */
+			Q921T200TimerStop(trunk, tei);
+			Q921T203TimerStart(trunk, tei);
+
+			link->vs = 0;
+			link->va = 0;
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+		} else {
+			/* MDL Error indication (C, D) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame is not a response to a request\n");
+
+			/* no state change */
+		}
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		if(pf) {
+			/* DL Release confirm */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE_CONFIRM, tei, NULL, 0);
+
+			/* Stop T200 */
+			Q921T200TimerStop(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, tei);
+		} else {
+			/* MDL Error indication (D) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame is not a response to a request\n");
+
+			/* no state change */
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* MDL Error indication (C, D) */
+		Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame in invalid state\n");
+
+		/* no state change */
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcDISC
+ * \brief	Handle incoming DISC
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcDISC(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf  = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		/* Send DM */
+		Q921SendDM(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* Discard I queue */
+		MFIFOClear(link->IFrameQueue);
+
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+		
+		/* DL Release indication */
+		Q921Tx23Proc(trunk, Q921_DL_RELEASE, tei, NULL, 0);
+
+		/* Stop T200 */
+		Q921T200TimerStop(trunk, tei);
+
+		if(link->state == Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+			/* Stop T203 */
+			Q921T203TimerStop(trunk, tei);
+		}
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, tei);
+		break;
+
+	default:
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid DISC received in state \"%s\" (%d)", Q921State2Name(link->state), link->state);
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcRR
+ * \brief	Handle incoming RR
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcRR(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		if (Q921_IS_COMMAND(trunk, cr)) { /* if this is a command */
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication */
+			}
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+
+			if(nr == link->vs) {
+				/* V(A) = N(R) */
+				link->va = nr;
+
+				/* Stop T200, restart T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerReset(trunk, tei);
+
+			} else if(nr == link->va) {
+
+				/* do nothing */
+
+			} else {
+				/* V(A) = N(R) */
+				link->va = nr;
+
+				/* Restart T200 */
+				Q921T200TimerReset(trunk, tei);
+			}
+			/* no state change */
+
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Stop T200, start T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerStart(trunk, tei);
+
+				/* Invoke retransmission */
+				Q921InvokeRetransmission(trunk, tei, nr);
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	default:
+		break;
+	}
+	return 1;
+}
+
+
+/**
+ * Q921ProcREJ
+ * \brief	Handle incoming REJ
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcREJ(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command? */
+		if(Q921_IS_COMMAND(trunk, cr)) {
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication (A) */
+			}
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			/* Stop T200, start T203 */
+			Q921T200TimerStop(trunk, tei);
+			Q921T203TimerStart(trunk, tei);
+
+			/* Invoke retransmission of frame >N(R)  (?) */
+			Q921InvokeRetransmission(trunk, tei, nr);
+
+			/* no state change */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P ? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Stop T200, start T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerStart(trunk, tei);
+
+				/* Invoke retransmission */
+				Q921InvokeRetransmission(trunk, tei, nr);
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcRNR
+ * \brief	Handle incoming RNR
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+static int Q921ProcRNR(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* set peer receiver busy */
+		Q921_SET_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command? */
+		if(Q921_IS_COMMAND(trunk, cr)) {
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication (A) */
+			}
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			/* Stop T203, restart T200 */
+			Q921T200TimerReset(trunk, tei);
+			Q921T203TimerStop(trunk, tei);
+
+			/* no state change */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* set peer receiver busy */
+		Q921_SET_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(link->va <= nr && nr <= link->vs) {
+
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Restart T200 */
+				Q921T200TimerReset(trunk, tei);
+
+				/* Invoke retransmission */
+				Q921InvokeRetransmission(trunk, tei, nr);
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, tei);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+#if 0
+static int Q921SetReceiverBusy(L2TRUNK trunk)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(!Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+			/* set own receiver busy */
+			Q921_SET_FLAG(link, Q921_FLAG_RECV_BUSY);
+
+			/* send RR response */
+			Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), link->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(!Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+			/* set own receiver busy */
+			Q921_SET_FLAG(link, Q921_FLAG_RECV_BUSY);
+
+			/* send RNR response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), link->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
 }
 
+static int Q921ClearReceiverBusy(L2TRUNK trunk)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		if(Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+			/* clear own receiver busy */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_RECV_BUSY);
+
+			/* send RNR response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), link->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+#endif
+
+static int Q921ProcIFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	/* common fields: get sapi, tei and cr */
+//	L2UCHAR sapi = (mes[0] & 0xfc) >> 2;
+//	L2UCHAR cr   = (mes[0] & 0x02) >> 1;
+	L2UCHAR tei  = (mes[1] & 0xfe) >> 1;
+	L2UCHAR pf   =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr   =  mes[3] >> 1;		/* receive sequence number */
+	L2UCHAR ns   =  mes[2] >> 1;		/* send sequence number */
+	L2UCHAR discard = 0;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* Ignore I frames in earlier states */
+	if(link->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+		Q921Log(trunk, Q921_LOG_NOTICE, "I frame in invalid state ignored\n");
+		return 0;
+	}
+
+	/* Receiver busy? */
+	if(Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+		/* discard information */
+		discard = 1;
+
+		if(pf) {
+			/* send RNR Response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+			/* Clear ack pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+		}
+	}
+	else {
+		if(ns != link->vr) {
+			/* discard information */
+			discard = 1;
+
+			if(Q921_CHECK_FLAG(link, Q921_FLAG_REJECT) && pf) {
+
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+			}
+			else if(!Q921_CHECK_FLAG(link, Q921_FLAG_REJECT)){
+
+				/* set reject exception */
+				Q921_SET_FLAG(link, Q921_FLAG_REJECT);
+
+				/* Send REJ response */
+				Q921SendREJ(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, pf);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+			}
+		}
+		else {
+			/* V(R) = V(R) + 1 */
+			Q921_INC_COUNTER(link->vr);
+
+			/* clear reject exception */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_REJECT);
+
+			/* DL-Data indication */
+			Q921Tx23Proc(trunk, Q921_DL_DATA, tei, mes, size);
+
+			if(pf) {
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+			}
+			else if(!Q921_CHECK_FLAG(link, Q921_FLAG_ACK_PENDING)) {
+				/* ack pending */
+
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 0);
+				
+				/* set ack pending*/
+				Q921_SET_FLAG(link, Q921_FLAG_ACK_PENDING);
+			}
+		}
+	}
+
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(link->va <= nr && nr <= link->vs) {
+			if(Q921_CHECK_FLAG(link, Q921_FLAG_PEER_RECV_BUSY)) {
+				link->va = nr;
+			}
+			else if(nr == link->vs) {
+				/* V(A) = N(R) */
+				link->va = nr;
+
+				/* stop t200, restart t203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerReset(trunk, tei);
+			}
+			else if(nr != link->va) {
+				/* V(A) = N(R) */
+				link->va = nr;
+
+				/* restart T200 */
+				Q921T200TimerReset(trunk, tei);
+			}
+
+			/* Restart TM01 */
+			if(Q921_IS_NT(trunk)) {
+				Q921TM01TimerReset(trunk, tei);
+			}
+		}
+		else {
+			/* N(R) error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(link->va <= nr && nr <= link->vs) {
+			/* V(A) = N(R) */
+			link->va = nr;
+
+			/* Restart TM01 */
+			if(Q921_IS_NT(trunk)) {
+				Q921TM01TimerReset(trunk, tei);
+			}
+		}
+		else {
+			/* N(R) error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+
+static int Q921ProcSFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR sv = (mes[2] & 0x0c) >> 2;	/* supervisory format id */
+	//L2UCHAR pf = mes[3] & 0x01;		/* poll / final flag */
+	//L2UCHAR nr = mes[3] >> 1;		/* receive sequence number */
+	L2INT res = -1;
+
+	switch(sv) {
+	case 0x00:	/* RR : Receive Ready */
+		res = Q921ProcRR(trunk, mes, size);
+		break;
+
+	case 0x02:	/* RNR : Receive Not Ready */
+		res = Q921ProcRNR(trunk, mes, size);
+		break;
+
+	case 0x04:	/* REJ : Reject */
+		res = Q921ProcREJ(trunk, mes, size);
+		break;
+
+	default:	/* Invalid / Unknown */
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid S frame type %d\n", sv);
+		break;
+	}
+
+	return res;
+}
+
+
+
+static int Q921ProcUFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size) 
+{
+	L2UCHAR m  = (mes[2] & 0xe0) >> 3 | (mes[2] & 0x0c) >> 2;	/* modifier function id */
+//	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2INT res = -1;
+
+	switch(m) {
+	case 0x00:	/* UN : Unnumbered Information */
+		if(mes[3] == Q921_LAYER_ENT_ID_TEI)
+		{
+			if(!Q921_IS_PTMP(trunk)) {
+				/* wtf? nice try */
+				return res;
+			}
+
+			switch(mes[6]) {
+			case Q921_TEI_ID_REQUEST:	/* (TE ->) NT */
+				res = Q921TeiProcAssignRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_ASSIGNED:	/* (NT ->) TE */
+			case Q921_TEI_ID_DENIED:
+				res = Q921TeiProcAssignResponse(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_CHECKREQ:	/* (NT ->) TE */
+				res = Q921TeiProcCheckRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_CHECKRESP:	/* (TE ->) NT */
+				res = Q921TeiProcCheckResponse(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_REMOVE:	/* (NT ->) TE */
+				res = Q921TeiProcRemoveRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_VERIFY:	/* (TE ->) NT */
+				res = Q921TeiProcVerifyRequest(trunk, mes, size);
+				break;
+
+			default:			/* Invalid / Unknown */
+				Q921Log(trunk, Q921_LOG_ERROR, "Invalid UN message from TEI management/endpoint\n");
+				break;
+			}
+		}
+		else if(mes[3] == Q921_LAYER_ENT_ID_Q931) {
+
+			Q921Log(trunk, Q921_LOG_DEBUG, "UI Frame for Layer 3 received\n");
+
+			res = Q921Tx23Proc(trunk, Q921_DL_UNIT_DATA, 0, mes, size);
+		}
+		break;
+
+	case 0x03:	/* DM : Disconnect Mode */
+		res = Q921ProcDM(trunk, mes, size);
+		break;
+
+	case 0x08:	/* DISC : Disconnect */
+		res = Q921ProcDISC(trunk, mes, size);
+		break;
+
+	case 0x0c:	/* UA : Unnumbered Acknowledgement */
+		res = Q921ProcUA(trunk, mes, size);
+		break;
+
+	case 0x0f:	/* SABME  : Set Asynchronous Balanced Mode Extend */
+		res = Q921ProcSABME(trunk, mes, size);
+		break;
+
+	case 0x11:	/* FRMR : Frame Reject */
+	case 0x17:	/* XID : Exchange Identification */
+		res = 0;
+		break;
+
+	default:	/* Unknown / Invalid */
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid U frame type: %d\n", m);
+		break;
+	}
+
+	return res;
+}
+
+
 /*****************************************************************************
 
   Function:     Q921Rx12
